package com.bsoft.api.service.Impl;

import com.bsoft.api.mapper.DicDimMapper;
import com.bsoft.api.mapper.SerPageBlockRsMapper;
import com.bsoft.api.model.DicDim;
import com.bsoft.api.model.SerPageBlockRs;
import com.bsoft.api.service.BlockValuesService;
import org.apache.ibatis.binding.MapperMethod;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.List;
import java.util.Map;

public class BlockValuesServiceImpl extends BlockValuesService {

    @Autowired
    private SerPageBlockRsMapper serPageBlockRsMapper;
    @Autowired
    private DicDimMapper dicDimMapper;

    private String disease = null;
    private String doctor = null;
    private String department = null;
    private String time = null;

        public List<Map<String,Object>> getBlockValuesByPageID(String pageId,String disease,String doctor,String department,String time){
            //根据pageId查询所有板块
            List<SerPageBlockRs> list =serPageBlockRsMapper.selectByPageId(pageId);
            //根据pageId查询所有维度
            List<DicDim> dimList = dicDimMapper.selectByPageid(pageId);
            //循环获取需要添加的维度查询条件
            for (DicDim data : dimList) {
                if(data.getDimField().equals("disease")){
                    this.disease=data.getDimField();
                }
                if(data.getDimField().equals("doctor")){
                    this.doctor=data.getDimField();
                }
                if(data.getDimField().equals("department")){
                    this.department=data.getDimField();
                }
                if(data.getDimField().equals("time")){
                    this.time=data.getDimField();
                }
            }
            //循环获取数据
            for (SerPageBlockRs data : list) {
                //获取表名
                String tableName = "VAL_BLOCK_VALUES_"+data.getBlockId();

                String selectSql = "select * from"+tableName;
                String whereSql = "where 1=1";

                //添加查询条件
                if(disease!=null&&this.disease!=null){
                    whereSql+=String.format(" and disease='{0}'",disease);
                }
                if(doctor!=null&&this.doctor!=null){
                    whereSql+=String.format(" and doctor='{0}'",doctor);
                }
                if(department!=null&&this.department!=null){
                    whereSql+=String.format(" and department='{0}'",department);
                }
                if(time!=null&&this.time!=null){
                    whereSql+=String.format(" and time='{0}'",time);
                }

            }
            return  null;
        }


}
